C This program displays zefsa3d output using TEK4105
C graphics commands.  Alternatively, it outputs a PostScript file.

C Written by Michael W. Deem 2 September 1988.
C Updated by Michael W. Deem 29 January 1991.
C Updated by Michael W. Deem 28 June 1991.
C Corporate Research, Exxon Research & Engineering, Annandale, NJ, USA.

C Updated 11.28.89 John M. Newsam  CATL::[NEWSAM.DEEM.ZEFSA_NOV89]DI1_NEW
C Updated 22 March 1990 by M. W. Deem.
C Updated 8 July 1990 by M. W. Deem.

      program DISPLAY3D

      include 'zefsa3d.inc'

      common /jtitls/ ctitle, cdate, ctime
      character cdate*9, ctime*8, ctitle*16

      logical ok, RDFILE, I_GRID, GROUP
      integer*2 i, j, k
      character chr
      real*4 e_min, e, t

      print *,'Display of output of ZEFSA3D program'
      print *,'Author: Michael W. Deem'
      print *,'Corporate Research, Exxon Research & Engineering'
      PI = 4.0 * atan(1.0)
      call date(cdate)
      call time(ctime)
      k = 2
      ok = RDFILE(k)
      if (ok) call CONST()
      if (ok) call PR_CON()
      if (ok) ok = GROUP()
      if (ok) call I_XYZ()
      if (ok) ok = I_GRID()
      if (.not. ok) stop
      j = 0
      print *,'Enter Title (A16) for plots'
      read '(A16)', ctitle
      print *,'Enter 1 for PostScript file output'
      read *, k
      postout = k .eq. 1
      print *,'Enter maximum energy for displayed structures'
      read *, e_min
      if (.not. postout) call TK4105(0.0,0.0,1)
10    read(2,*,END=100) e, t
      do 20 i = 1, n_atoms
20      read(2,*) a_pos(1,i), a_pos(2,i), a_pos(3,i)
      do 30 i = 1, n_cyl
30      read(2,*) cyl_pos(1,i), cyl_pos(2,i), cyl_pos(3,i)
      do 40 i = 1, n_sph
40      read(2,*) sph_pos(1,i), sph_pos(2,i), sph_pos(3,i)
      if (e .gt. e_min) goto 10
      j = j + 1
      call I_DISP()
      call DISPLY(a_pos, e, t, 1.0, j, 1)
      if (postout) then
        print *,'PostScript file ',j,' created'
      else
        write(*,'(28x,'' Press return to continue'')')
        read(*,'(A)') chr
      end if
      goto 10
100   if (.not. postout) call TK4105(0.0,0.0,0)
      close(2)
      end


C This routine initializes the graphics display.
      subroutine I_DISP()

      include 'zefsa3d.inc'

      integer*2 i

      if (.not. postout) call TK4105(0.0, 0.0, 6)
      pap_x1 = 0.0
      pap_x2 = -c_x3
      if (pap_x2 - c_x2 .lt. 0.0) then
        pap_x1 = c_x2 + c_x3
        pap_x2 = 0.0
      end if
      pap_x1 = pap_x1 + NEIGHBOR
      pap_x2 = pap_x2 + NEIGHBOR
      pap_x = pap_x2 + max(c_x1, c_x1-c_x3) + max(-c_y2,0.0) - x_off
     |                   + 3.0*NEIGHBOR
      pap_y = z_max + 4.0*NEIGHBOR
      pap_max = max(pap_x + c_y1+max(c_y2,0.0), pap_y + c_y1)
     |           + NEIGHBOR
      return
      end


C This routine displays the current position of the atoms.
      subroutine DISPLY(pos, e, t, sheat, n_j, n_i)

      include 'zefsa3d.inc'

      common /jtitls/ ctitle, cdate, ctime
      character cdate*9, ctime*8, ctitle*16

      real*4 t, sheat, pos(3, MAX_ATOMS), e
      integer*2 n_j, n_i

      logical first, ok, i_degen, MK_UNI, MK2_CON, ltmp, coord4
      integer*2 i, j, i0, j0, k, k0, l, l0, l1, m, occup
      integer*2 minocc, maxocc, nT, n2_bond(MAX_ATOMS)
      character*80 name
      real*4 x, y, z, tmp, LENGTH, LEN2, ENERGY, a, b, c, evec(7)

      data first /.true./

      LENGTH(i,j) = sqrt((c_x1*pos(1,i) + c_x2*pos(2,i) +
     |                     c_x3*pos(3,i) - x_off - ta2_pos(1,j))**2 +
     |                   (c_y1*pos(2,i) + c_y2*pos(3,i) - y_off
     |                   - ta2_pos(2,j))**2 +
     |                   (c_z1*pos(3,i) - ta2_pos(3,j))**2)

      LEN2(i,j) = sqrt((c_x1*ta_pos(1,i) + c_x2*ta_pos(2,i) +
     |                     c_x3*ta_pos(3,i) - x_off - ta2_pos(1,j))**2 +
     |                   (c_y1*ta_pos(2,i) + c_y2*ta_pos(3,i) - y_off
     |                   - ta2_pos(2,j))**2 +
     |                   (c_z1*ta_pos(3,i) - ta2_pos(3,j))**2)

      postunit = 4
      if (postout) then
        if (n_j .lt. 1000) write(name, '(A, I3, A)') 'pos',n_j,'.ps'
        if (n_j .lt. 100) write(name, '(A, I2, A)') 'pos',n_j,'.ps'
        if (n_j .lt. 10) write(name, '(A, I1, A)') 'pos',n_j,'.ps'
      else
        if (n_j .lt. 1000) write(name, '(A, I3, A)') 'pos',n_j,'.dat'
        if (n_j .lt. 100) write(name, '(A, I2, A)') 'pos',n_j,'.dat'
        if (n_j .lt. 10) write(name, '(A, I1, A)') 'pos',n_j,'.dat'
      end if
      open(postunit, file=name, status='UNKNOWN')
      if (postout) then
        call PSINIT(postunit)
        call PSPAGE(postunit)
        call PSFONT(postunit, 'Helvetica', 12.0)
        call PSFONT(postunit, 'Courier', 12.0)
        write(name,230) ctitle
        call PSWRITE(postunit, name)
        write(name,230) ctime
        call PSWRITE(postunit, name)
        write(name,230) cdate
        call PSWRITE(postunit, name)
        call PSWRITE(postunit, ' ')
      else
        write(postunit,'(6F12.5)') c_a, c_b, c_c, 180.0/PI*c_alpha, 
     |                    180.0/PI*c_beta, 180.0/PI*c_gamma
      end if
      do 10 i = 1, n_atoms
        if (i .lt. 10) then
          write(name, '(I1)') i
        else
          write(name, '(I2)') i
        end if
10      if (.not. postout) 
     |    write(postunit,'(A, 3F12.5)') 'T'//name(1:3), pos(1,i),
     |                                    pos(2,i), pos(3,i)
      ltmp = .true.
      tmp = ENERGY(pos,cyl_pos,sph_pos,i,j,coord4,k,evec,ltmp,1.0)
      if (postout) then
        write(name,'(A, 1P, E12.5)') '            t = ',t
        call PSWRITE(postunit, name)
        write(name,'(A, 1P, E12.5)') '            c = ',sheat
        call PSWRITE(postunit, name)
        write(name,'(A, 1P, E12.5)') '      e saved = ',e
        call PSWRITE(postunit, name)
        write(name,'(A, 1P, E12.5)') '       e calc = ',tmp
        call PSWRITE(postunit, name)
        write(name,'(A, 2I3)')       '         j, i = ',n_j, n_i
        call PSWRITE(postunit, name)
      else
        print *,'            t = ',t
        print *,'            c = ',sheat
        print *,'            e saved = ',e
        print *,'            e calc = ',tmp
        print *,'            j, i ',n_j,n_i
      end if
C box out the top display
C set color to red
      if (.not. postout) call TK4105(2.0, 0.0, 99)
      call TO_XY(x,y,0.0,0.0,0.0)
      if (postout) then
        call PSMOVE(postunit, x, y+1.0)
      else
        call TK4105(x,y,2)
      end if
      call TO_XY(x,y,1.0,0.0,0.0)
      if (postout) then
        call PSLINE(postunit, x, y+1.0)
      else
        call TK4105(x,y,3)
      end if
      call TO_XY(x,y,1.0,1.0,0.0)
      if (postout) then
        call PSLINE(postunit, x, y+1.0)
      else
        call TK4105(x,y,3)
      end if
      call TO_XY(x,y,0.0,1.0,0.0)
      if (postout) then
        call PSLINE(postunit, x, y+1.0)
      else
        call TK4105(x,y,3)
      end if
      call TO_XY(x,y,0.0,0.0,0.0)
      if (postout) then
        call PSLINE(postunit, x, y+1.0)
      else
        call TK4105(x,y,3)
      end if
      call PSCLOSE(postunit)
      call PSSTROKE(postunit)
C box out the front display
      call TO_XZ(x,z,0.0,0.0,0.0)
      if (postout) then
        call PSMOVE(postunit, x, z+1.0)
      else
        call TK4105(x,z,2)
      end if
      call TO_XZ(x,z,1.0,0.0,0.0)
      if (postout) then
        call PSLINE(postunit, x, z+1.0)
      else
        call TK4105(x,z,3)
      end if
      call TO_XZ(x,z,1.0,0.0,1.0)
      if (postout) then
        call PSLINE(postunit, x, z+1.0)
      else
        call TK4105(x,z,3)
      end if
      call TO_XZ(x,z,0.0,0.0,1.0)
      if (postout) then
        call PSLINE(postunit, x, z+1.0)
      else
        call TK4105(x,z,3)
      end if
      call TO_XZ(x,z,0.0,0.0,0.0)
      if (postout) then
        call PSLINE(postunit, x, z+1.0)
      else
        call TK4105(x,z,3)
      end if
      call PSCLOSE(postunit)
      call PSSTROKE(postunit)
C box out the right display
      call TO_YZ(y,z,0.0,0.0,0.0)
      if (postout) then
        call PSMOVE(postunit, y, z+1.0)
      else
        call TK4105(y,z,2)
      end if
      call TO_YZ(y,z,0.0,1.0,0.0)
      if (postout) then
        call PSLINE(postunit, y, z+1.0)
      else
        call TK4105(y,z,3)
      end if
      call TO_YZ(y,z,0.0,1.0,1.0)
      if (postout) then
        call PSLINE(postunit, y, z+1.0)
      else
         call TK4105(y,z,3)
      end if
      call TO_YZ(y,z,0.0,0.0,1.0)
      if (postout) then
        call PSLINE(postunit, y, z+1.0)
      else
        call TK4105(y,z,3)
      end if
      call TO_YZ(y,z,0.0,0.0,0.0)
      if (postout) then
        call PSLINE(postunit, y, z+1.0)
      else
        call TK4105(y,z,3)
      end if
      call PSCLOSE(postunit)
      call PSSTROKE(postunit)
C draw atoms as boxes in top display
C degenerate atoms are half size
      nT = 0
      do 20 i = 1, n_atoms*n_symm
        tmp = A_SIZE
        if (degen(i)) then
C set color to dark blue
          if (.not. postout) call TK4105(4.0, 0.0, 99)
          tmp = 0.5 * tmp
        else
C set color to yellow
          if (.not. postout) call TK4105(7.0, 0.0, 99)
          nT = nT + 1
        end if
        call TO_XY(x, y, ta_pos(1,i), ta_pos(2,i), ta_pos(3,i))
        if (postout) then
          call PSMOVE(postunit,x-tmp,y-tmp+1.0)
          call PSLINE(postunit,x-tmp,y+tmp+1.0)
          call PSLINE(postunit,x+tmp,y+tmp+1.0)
          call PSLINE(postunit,x+tmp,y-tmp+1.0)
          call PSCLOSE(postunit)
          call PSSTROKE(postunit)
        else
          call TK4105(x-tmp,y-tmp,2)
          call TK4105(x-tmp,y+tmp,3)
          call TK4105(x+tmp,y+tmp,3)
          call TK4105(x+tmp,y-tmp,3)
          call TK4105(x-tmp,y-tmp,3)
        end if
20      continue
C loop over atoms in cell to find bonds
C set color to light blue
      if (.not. postout) call TK4105(5.0, 0.0, 99)
      minocc = 100
      maxocc = 0
      do 40 i = 1, n_atoms*n_symm
        occup = 0
        i_degen = degen(i)
        a = ta_pos(1,i)
        b = ta_pos(2,i)
        c = ta_pos(3,i)
C TO_XYZ MACRO
        x = c_x1*a + c_x2*b + c_x3*c - x_off
        y = c_y1*b + c_y2*c - y_off
        z = c_z1*c
C TO_GRD MACRO
        i0 = min(max(int((x+BOND)/dx_grid)+1,1),nx_grid)
        j0 = min(max(int((y+BOND)/dy_grid)+1,1),ny_grid)
        k0 = min(max(int((z+BOND)/dz_grid)+1,1),nz_grid)
        l0 = max(i0-1,1)
        l1 = min(i0+1, nx_grid)
C z loop
        do 30 j = max(k0-1,1), min(k0+1, nz_grid)
C y loop
          do 30 k = max(j0-1,1), min(j0+1, ny_grid)
C x loop; loop over all elements under this pointer
            do 30 l = grid(1,l0,k,j), grid(1,l1,k,j)+
     |                                grid(2,l1,k,j)-1
C make sure this atom is not atom i
            if (ta_from(l) .ne. i) then
C to be degenerate to atom i, it must degenerate and equivalent
C   to atom i
              x = LEN2(i,l)
              m = ta_iden(l)
C make sure this atom is not degenerate
              if (.not. degen(m) .and. x .lt. BOND) then
                if (x .lt. NEIGHBOR) then
                  occup = occup + 1
                  x = ta2_pos(1,l) + x_off
                  y = ta2_pos(2,l) + y_off
                  z = ta2_pos(3,l)
C TO_ABC macro
                  a = c_a1*x + c_a2*y + c_a3*z
                  b = c_b1*y + c_b2*z
                  c = c_c1*z
                  if (mod(i-1,n_symm) .eq. 0 .and.
     |                .not. i_degen) then
                    x = 0.5*(ta_pos(1,i) + a)
                    y = 0.5*(ta_pos(2,i) + b)
                    z = 0.5*(ta_pos(3,i) + c)
                    if (.not. postout)
     |                   write(postunit,'(A, 3F12.5)') 'O ', x, y, z
                  end if
C draw in top display
                  call TO_XY(x, y, ta_pos(1,i), ta_pos(2,i),
     |                              ta_pos(3,i))
                  if (postout) then
                    call PSMOVE(postunit, x, y+1.0)
                    call PSLINE(postunit, (ta2_pos(1,l)-c_x3*c+pap_x1)
     |                         *PAP_SIZ/pap_max,
     |                         (ta2_pos(2,l)-c_y2*c+pap_y)
     |                         *PAP_SIZ/pap_max+1.0)
                    call PSSTROKE(postunit)
                  else
                    call TK4105(x, y, 2)
                    call TK4105((ta2_pos(1,l)-c_x3*c+pap_x1)
     |                         *PAP_SIZ/pap_max,
     |                         (ta2_pos(2,l)-c_y2*c+pap_y)
     |                         *PAP_SIZ/pap_max,
     |                         3)
                  end if
C draw in front display
                  call TO_XZ(x, z, ta_pos(1,i), ta_pos(2,i),
     |                              ta_pos(3,i))
                  if (postout) then
                    call PSMOVE(postunit, x, z+1.0)
                    call PSLINE(postunit, (ta2_pos(1,l)-c_x2*b+pap_x2)
     |                         *PAP_SIZ/pap_max,
     |                         (ta2_pos(3,l)+NEIGHBOR)*PAP_SIZ/pap_max
     |                          +1.0)
                    call PSSTROKE(postunit)
C draw in right display
                  else
                    call TK4105(x, z, 2)
                    call TK4105((ta2_pos(1,l)-c_x2*b+pap_x2)
     |                         *PAP_SIZ/pap_max,
     |                         (ta2_pos(3,l)+NEIGHBOR)*PAP_SIZ/pap_max,
     |                         3)
                  end if
C draw in right display
                  call TO_YZ(y, z, ta_pos(1,i), ta_pos(2,i),
     |                              ta_pos(3,i))
                  if (postout) then
                    call PSMOVE(postunit, y, z+1.0)
                    call PSLINE(postunit, (ta2_pos(2,l)+pap_x)
     |                         *PAP_SIZ/pap_max,
     |                         (ta2_pos(3,l)+NEIGHBOR)*PAP_SIZ/pap_max
     |                          +1.0)
                    call PSSTROKE(postunit)
                  else
                    call TK4105(y, z, 2)
                    call TK4105((ta2_pos(2,l)+pap_x)
     |                         *PAP_SIZ/pap_max,
     |                         (ta2_pos(3,l)+NEIGHBOR)*PAP_SIZ/pap_max,
     |                         3)
                  end if
                end if
              end if
            end if
30          continue
        if (mod(i-1,n_symm) .eq. 0 .and. .not. i_degen) then
          minocc = min(occup, minocc)
          maxocc = max(occup, maxocc)
        end if
40      continue
C place graphics cursor
      if (postout) then
        call PSWRITE(postunit, ' ')
        write(name,200) minocc
        call PSWRITE(postunit, name)
        write(name,210) maxocc
        call PSWRITE(postunit, name)
        write(name,220) nT
        call PSWRITE(postunit, name)
      else
        call TK4105(0.0, 6.2, 2)
        write(*,100) minocc, ctitle
        write(*,110) maxocc
        write(*,120) nT, ctime, cdate
      end if
C MWD 16 September 1999 change
C      if (coord4) then
C save specified coordination numbers
        do 50 i = 1, n_atoms*n_symm
50        n2_bond(i) = n_bond(i)
C MWD 16 September 1999 change
C        ltmp = .true.
        ltmp = .false.
        ok = MK2_CON(ltmp)
        if (ok) ok = MK_UNI(nT)
C        call DUMP_CON(nT)
        i = 1
        if (ok) call COORD(nT, i)
C restore specified coordination numbers
        do 60 i = 1, n_atoms*n_symm
60        n_bond(i) = n2_bond(i)
C MWD 16 September 1999 change
C      end if
      if (postout) then
        call PSSHOWP(postunit)
        call PSEND(postunit)
      else
        call TK4105(0.0,0.0,10)
      end if
      close(postunit)
      return
100   format(1X,'minimum occupancy: ',I3,5x,A16)
110   format(1X,'maximum occupancy: ',I3)
120   format(1X,'number of T-atoms: ',I3,2x,A,2x,A)
200   format('minimum occupancy: ',I3,5x,A16)
210   format('maximum occupancy: ',I3)
220   format('number of T-atoms: ',I3,2x,A,2x,A)
230   format(A)
      end
