      implicit none

C Note that matrices are defined as Col, Row, not Row, Col.
C This is backwards of the normal convention.
C constant declarations
      integer*2 MAX_UNIQ, MAX_CLOSE, MAX_SYMM, MAX_TA, MAX_GRID,
     |          N_MISS, BOND_KNOTS, ANGL_KNOTS, DEGN_KNOTS, MAX_ATOMS,
     |          MAX_COOR, MAX_SAVE, FREE, BONDINT, BONDEXT, MARKED,
     |          MAX_PORE, MAX_TYPE
c default parameters changed from these values :-
c          MAX_GRID=10
      parameter (MAX_UNIQ=36, MAX_CLOSE=9, MAX_SYMM=192, MAX_TA=2000,
     |           MAX_GRID=20, N_MISS=10, BOND_KNOTS=300, ANGL_KNOTS=100,
     |           DEGN_KNOTS=10, MAX_ATOMS=800, MAX_COOR=10,
     |           MAX_SAVE=600, FREE=0, MARKED=2, BONDINT=1, BONDEXT=-1,
     |           MAX_PORE=10, MAX_TYPE=2)
      real*4 PAP_SIZ, A_SIZE, T_LOW
      parameter (PAP_SIZ=5.0, A_SIZE=0.09)
      parameter (T_LOW=100.0)

C variable declarations
      integer*2 n_atoms, n_actual, n_oxy

      integer*2 bond_n, angl_n, aang_n, degn_n, proj_n, n_pores,
     |          n_sph, n_cyl
      real*4 bond_h, angl_h, aang_h, degn_h, bond_x0, angl_x0, aang_x0,
     |       degn_x0
      real*4 e_close(0:MAX_CLOSE),
     |       bond_y(BOND_KNOTS,MAX_TYPE,MAX_TYPE), 
     |       angl_y(ANGL_KNOTS,MAX_TYPE,MAX_TYPE,MAX_TYPE),
     |       aang_y(ANGL_KNOTS,MAX_TYPE),
     |       degn_y(DEGN_KNOTS,MAX_TYPE),
     |       bond_m(0:BOND_KNOTS,MAX_TYPE,MAX_TYPE),
     |       angl_m(0:ANGL_KNOTS,MAX_TYPE,MAX_TYPE,MAX_TYPE),
     |       aang_m(0:ANGL_KNOTS,MAX_TYPE),
     |       degn_m(0:DEGN_KNOTS,MAX_TYPE),
     |       proj_vec(3,3), sph_max(MAX_PORE),
     |       sph_rad(MAX_PORE), cyl_max(MAX_PORE),
     |       cyl_rad(MAX_PORE), cyl_axis(3,MAX_PORE),
     |       wt_bond, wt_angl, wt_aang, wt_degn, wt_coor,
     |       wt_proj, wt_pore, wt_pxd, p_bond, p_angl, p_aang,
     |       p_degn, p_coor, p_proj, p_pore, p_pxd

      real*4 c_a, c_b, c_c, c_alpha, c_beta, c_gamma, c_vol

      integer*4 n_symm
      real*4 symm_m(3,3,MAX_SYMM), symm_v(3,MAX_SYMM), transl(3,27)

      real*4 c_x1, c_x2, c_x3, c_y1, c_y2, c_z1, c_a1, c_a2, c_a3,
     |       c_b1, c_b2, c_c1, rec_x1, rec_y1, rec_y2, rec_z1,
     |       rec_z2, rec_z3

      integer*2 a_from(MAX_TA), ta_from(MAX_TA), ta_iden(MAX_TA),
     |          cell_fr(MAX_TA), a_type(MAX_UNIQ), degn_eq(MAX_ATOMS)
      real*4 a_pos(3,MAX_UNIQ), a2_pos(3,MAX_UNIQ)
      real*4 sph_pos(3, MAX_PORE), sph2_pos(3, MAX_PORE)
      real*4 cyl_pos(3, MAX_PORE), cyl2_pos(3, MAX_PORE)
      real*4 ta_pos(3,MAX_ATOMS), ta2_pos(3,MAX_TA), d_fact(MAX_UNIQ)

      real*4 PI

      integer*4 nx_grid, ny_grid, nz_grid
      integer*2 grid(2,MAX_GRID, MAX_GRID, MAX_GRID)
      real*4 dx_grid, dy_grid, dz_grid, x_grid, y_grid, z_grid,
     |       a0_grid, a1_grid, b0_grid, b1_grid, c0_grid, c1_grid

      real*4 x_max, y_max, z_max, xyz_max, x_off, y_off

      logical degen(MAX_ATOMS)

      real*4 pap_x, pap_y, pap_x1, pap_x2, pap_max

      integer*2 r_seed

      real*4 temp_1, temp_2, tfact1, tfact2, tfact3

      integer*2 n_bond(MAX_ATOMS)
      real*4 bond, close, neighbor, close2

      integer*2 mult_t(MAX_SYMM, MAX_SYMM)

      real*4 step_a, step_b, step_m

      logical write_4
      integer*4 max_wr4
      real*4 max_en4

      integer*2 conlist(2, MAX_CLOSE, MAX_ATOMS),
     |          atommap(0:MAX_ATOMS)

      logical pxd, geomet, nooxy

      logical postout
      integer*2 postunit

C global storage: common blocks
      common /atoms/ n_atoms, n_actual, n_oxy
      common /energ/ bond_n, angl_n, aang_n, degn_n, proj_n, n_pores,
     |               n_sph, n_cyl, bond_h, angl_h, aang_h, degn_h,
     |               bond_x0, angl_x0, aang_x0, degn_x0,
     |               e_close, bond_y, angl_y, aang_y, degn_y,
     |               bond_m, angl_m, aang_m, degn_m, proj_vec,
     |               sph_max, sph_rad, cyl_max, cyl_rad, cyl_axis,
     |               wt_bond, wt_angl, wt_aang, wt_degn, wt_coor,
     |               wt_proj, wt_pore, wt_pxd, p_bond, p_angl, p_aang, 
     |               p_degn, p_coor, p_proj, p_pore, p_pxd
      common /cell/ c_a, c_b, c_c, c_alpha, c_beta,
     |              c_gamma, c_vol
      common /symmet/ n_symm, symm_m, symm_v, transl
      common /consta/ c_x1, c_x2, c_x3, c_y1, c_y2, c_z1,
     |                c_a1, c_a2, c_a3, c_b1, c_b2, c_c1,
     |                rec_x1, rec_y1, rec_y2, rec_z1, rec_z2,
     |                rec_z3
      common /atoms2/ a_pos, sph_pos, sph2_pos, cyl_pos, cyl2_pos,
     |               a2_pos, ta_pos, ta2_pos, d_fact, a_from, ta_from,
     |               ta_iden, cell_fr, a_type, degn_eq
      common /transc/ PI
      common /pointr/ nx_grid, ny_grid, nz_grid,
     |                dx_grid, dy_grid, dz_grid,
     |                x_grid, y_grid, z_grid, grid,
     |                a0_grid, a1_grid, b0_grid, b1_grid,
     |                c0_grid, c1_grid
      common /xyzvar/ x_max, y_max, z_max, xyz_max, x_off, y_off
      common /sdegen/ degen
      common /grafcs/ pap_x, pap_y, pap_x1, pap_x2, pap_max
      common /random/ r_seed
      common /temper/ temp_1, temp_2, tfact1, tfact2, tfact3
      common /bonds/ bond, close, neighbor, close2, n_bond
      common /groupp/ mult_t
      common /steps/ step_a, step_b, step_m
      common /output/ write_4, max_wr4, max_en4
      common /topolo/ conlist, atommap
      common /powder/ pxd, geomet, nooxy
      common /postscri/ postout, postunit
