/*

  (C) 1997 Marco Falcioni

  Box object: a list of atoms

*/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include "error.h"
#include "misc.h"
#include "box.h"

struct Box * new_Box(void)
{
  long i;
  struct Box * B;
  
  B = (struct Box *) Malloc(sizeof(struct Box));
  B->near = (struct Box **) Malloc(27*sizeof(struct Box *));
  for(i = 0; i < 27; i++) {
    B->near[i] = 0;
  }
  B->list = new_Chain();
  B->n = 0;
  return B;
}

void delete_Box(struct Box * B)
{
  if(B == 0) return;
  Free(B->near);
  clean_Chain(B->list);
  delete_Chain(B->list);
  Free(B);
  return;
}

void print_Box(const struct Box * B, FILE * stream)
{
  long i;
  if(B == 0 || stream == 0) {
    push_generic_error("print_Box","(nil) args passed");
    exit_clean();
  }
  fprintf(stream,"Box at %p\n",B);
  fprintf(stream,"  B->list = %p\n",B->list);
  print_Chain(B->list,stream);
  fprintf(stream,"  B->n = %ld\n",B->n);
  for(i = 0; i < 27; i++) {
    fprintf(stream,"  B->near[%ld] = %p\n", i, B->near[i]);
  }
  return;
}

