/*

  1998 (C) Marco Falcioni UCLA

  the data I wish to store and save during the MC run


  (C) 1997 Marco Falcioni (falcioni@ucla.edu)

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,
  USA.

  http://www.fsf.org/copyleft/gpl.html



*/

#ifndef __conf_h
#define __conf_h

#include <stdio.h>

#define ENERGIES 8

struct Positions;

struct Conf {
  unsigned long n_unique;

  double tot_energy;
  double RP_energy;
  double Pos_energy;

  /* arranged a like so: 
     0        1        2         3           4        5       6       7
     bond_len bond_ene angle_ene avangle_ene non_bond #_bonds merge_d #_atoms

   */

  double * ene[ENERGIES]; /* array of energies per unique atom */

  double * pos[3]; /* array of positions per unique atom */

  struct Conf * next;

};


struct Conf * new_Conf(unsigned long uniq);
void delete_Conf(struct Conf * me);
/* a = b */
void  copy_Conf(struct Conf * a, const struct Conf * b);
void  pcopy_Conf(struct Conf * a, struct Positions * b);
void print_Conf(struct Conf * me, FILE * stream);
int read_Conf(struct Conf * conf, FILE * stream);
void sprint_Conf(struct Conf * me, char * buffer);
void fprint_Conf(struct Conf * me, FILE * stream);
#endif
