/* Created: [GJ] Sun Apr 20 05:51:06 EDT 1997
 */
#include <limits.h>
#include "constants.h"

const int  max_int = INT_MAX;
const int  min_int = INT_MIN;
const long int max_long = LONG_MAX;
const long int min_long = LONG_MIN;
const unsigned int  max_uint = UINT_MAX;
const unsigned long max_ulong = ULONG_MAX;

#ifdef FLT_MAX
const float  max_float = FLT_MAX;
const float  min_float = FLT_MIN;
#else
const float  max_float = 3.40e+38;
const float  min_float = 1.5e-45;
#endif

#ifdef DBL_MAX
const double max_double = DBL_MAX;
const double min_double = DBL_MIN;
#else
const double max_double = 1.e+305;
const double min_double = 1.e-305;
#endif


/* derived limit constants */

#ifdef DBL_MAX_10_EXP
const double log_max_double = DBL_MAX_10_EXP*constLn10_;
const double log_min_double = DBL_MIN_10_EXP*constLn10_;
#else
const double log_max_double = 650.;
const double log_min_double = -650.;
#endif

const double dbl_precision = 1.e-14;
const double sgl_precision = 1.e-6;
const double log_dbl_precision = -32.2;
const double log_sgl_precision = -13.8;
const double inv_dbl_precision = 1.e+14;
const double inv_sgl_precision = 1.e+6;



void dump_constants(FILE *fd)
{
  fprintf(fd,"max_int: %d\n", max_int);
  fprintf(fd,"min_int: %d\n", min_int);

  fprintf(fd,"max_long: %ld\n", max_long);
  fprintf(fd,"min_long: %ld\n", min_long);

  fprintf(fd,"max_uint: %d\n", max_uint);
  fprintf(fd,"max_ulong: %ld\n", max_ulong);

  fprintf(fd,"max_float: %g\n", max_float);
  fprintf(fd,"min_float: %g\n", min_float);

  fprintf(fd,"max_double: %g\n", max_double);
  fprintf(fd,"min_double: %g\n", min_double);

  fprintf(fd,"log_max_double: %g\n", log_max_double);
  fprintf(fd,"log_min_double: %g\n", log_min_double);

  fprintf(fd,"dbl_precision: %g\n", dbl_precision);
  fprintf(fd,"sgl_precision: %g\n", sgl_precision);

  fprintf(fd,"log_dbl_precision: %g\n", log_dbl_precision);
  fprintf(fd,"log_sgl_precision: %g\n", log_sgl_precision);

  fprintf(fd,"inv_dbl_precision: %g\n", inv_dbl_precision);
  fprintf(fd,"inv_sgl_precision: %g\n", inv_sgl_precision);
}
