/*

  Marco Falcioni (C) 1998 UCLA

  write a datafile in a standard XTL form
  
  (C) 1998 Marco Falcioni (falcioni@ucla.edu)

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,
  USA.

  http://www.fsf.org/copyleft/gpl.html

*/

#include <stdio.h>
#include <stdlib.h>

#include "error.h"

#include "positions.h"
#include "cell.h"
#include "symmetry.h"
#include "misc.h"
#include "functions.h"
#include "params.h"
#include "rad_pattern.h"
#include "SP_entry.h"
#include "spline.h" 

void write_XTL(struct Positions * T, struct Cell * C, struct Sym_group * G, 
	       FILE * stream)
{

  if(stream == 0 || T == 0 || C == 0 || G == 0) {
    push_generic_error("write_XTL","(nil) args passed");
    exit_clean();
  }

  fprintf(stream, "TITLE Zeolite from Zefsa\n");

  fprintf(stream, "DIMENSION 3\n");

  write_Cell_XTL(C, stream);

  write_Sym_group_XTL(G, stream);

  fprintf(stream, "\n");

  write_unique_Positions_XTL(T,stream);

  fprintf(stream, "EOF\n");

  return;

}
